import java.io.PrintWriter;

/**
 * Der Abschluss einer Warteschlange.
 * 
 * @author Bernd Gramlich
 * @version 2012-11-21
 */
public class Abschluss extends Schlangenelement
{
    /**
     * Konstruktor.
     * Der Abschluss der Schlange enthlt nichts.
     * Deshalb braucht auch nichts getan zu werden.
     */
    public Abschluss ()
    {
    }

    /**
     * Nenne meinen Nachfolger.
     * Mein Nachfolger ist null, da ich der
     * Abschluss der Schlange bin.
     */
     public Schlangenelement gibNachfolger ()
     {
         return null;
     }

    /**
     * Nenne meinen Inhalt.
     * Mein Inhalt ist null, da ich der
     * Abschluss der Schlange bin.
     */
    public Vokabel gibInhalt ()
    {
        return null;
    }
    
    /**
     * Fge die "neueVokabel" in die nach aufsteigender
     * Punktzahl geordnete Vokabelschlange als n-te
     * Vokabel passend ein.
     * 
     * Da ich der Abschluss bin, erzeuge ich einen neuen
     * Knoten mit mir als Nachfolger. Den Verweis auf mich
     * selbst erziele ich durch das Java-Schlsselwort "this".
     */
    public Schlangenelement fuegePassendEin (int n, Vokabel neueVokabel)
    {
        return new Knoten (this, n, neueVokabel);
    }
     
    /**
     * Nenne die Lnge der Schlange von mir selbst ab.
     */
    public int gibLaenge ()
    {
        return 0;
    }
    
    /**
     * Nenne den geringsten Wissensstand innerhalb der
     * Schlange von mir selbst ab. (Das ist ein sehr
     * strenges Ma fr das erreichte Lernniveau. Je
     * grer das Ergebnis, um so hher der Erfolg.)
     * 
     * Da ich der Abschluss bin, gebe ich als Minimum
     * "plus unendlich" zurck.
     */
    public double gibGeringstesWissen ()
    {
        return Double.POSITIVE_INFINITY;
    }
    
    /**
     * Summiere innerhalb der Schlange von mir selbst
     * ab die Kehrwerte der Quadrate der Wissensstnde.
     * (Das ist ein grozgiges Ma fr das erreichte
     * Lernniveau. Je kleiner das Ergebnis, um so hher
     * der Erfolg.)
     */
    public double summiereReziprokquadratischesWissen ()
    {
        return 0;
    }
    
    /**
     * Verschiebe alle Punktzahlen innerhalb der Schlange
     * ab mir selbst um "summand".
     */
    public void verschiebePunkte (double summand)
    {
    }
    
    /**
     * Speichere den Inhalt der Schlange ab mir selbst
     * auf einen Schreiber.
     */
    public void speichereAuf (PrintWriter schreiber)
    {
    } 
 }
