import java.io.PrintWriter;

/**
 * Ein Element der Warteschlange.
 * Die Klasse ist abstrakt, da ein Schlangenelement
 * entweder ein Knoten (mit Daten) oder der Abschluss
 * der Schlange sein kann.
 * 
 * @author Bernd Gramlich 
 * @version 2012-11-21
 */
public abstract class Schlangenelement
{
    /*
     * Die Klasse selbst hat keinen Konstruktor, sondern nur
     * ihre Unterklassen.
     */
    
    /**
     * Nenne den Nachfolger des Schlangenelements.
     */
    public abstract Schlangenelement gibNachfolger ();

    /**
     * Nenne den Inhalt des Listenelements.
     */
    public abstract Vokabel gibInhalt ();
    
    /**
     * Fge die "neueVokabel" in die nach aufsteigender
     * Punktzahl geordnete Vokabelschlange passend ein.
     * Ich selbst bin die n-te Vokabel.
     */
    public abstract Schlangenelement fuegePassendEin
        (int n, Vokabel neueVokabel);
    
    /**
     * Nenne die Lnge der Schlange von mir selbst ab.
     */
    public abstract int gibLaenge ();
    
    /**
     * Nenne den geringsten Wissensstand innerhalb der
     * Schlange von mir selbst ab. (Das ist ein sehr
     * strenges Ma fr das erreichte Lernniveau. Je
     * grer das Ergebnis, um so hher der Erfolg.)
     */
    public abstract double gibGeringstesWissen ();
    
    /**
     * Summiere innerhalb der Schlange von mir selbst
     * ab die Kehrwerte der Quadrate der Wissensstnde.
     * (Das ist ein grozgiges Ma fr das erreichte
     * Lernniveau. Je kleiner das Ergebnis, um so hher
     * der Erfolg.)
     */
    public abstract double summiereReziprokquadratischesWissen ();
    
    /**
     * Verschiebe alle Punktzahlen innerhalb der Schlange
     * ab mir selbst um "summand".
     */
    public abstract void verschiebePunkte (double summand);
    
    /**
     * Speichere den Inhalt der Schlange ab mir selbst
     * auf einen Schreiber.
     */
    public abstract void speichereAuf (PrintWriter schreiber);
}
