import java.util.Scanner;

/**
 * Ein Vokabeltrainer.
 * 
 * @author Bernd Gramlich 
 * @version 2012-11-21
 */
public class Steuerung
{
    private static String version = "Cresce 0.0.4 Vokabeltrainer";
    private static String urheber = "(C) 2012 Bernd Gramlich";
    
    /**
     * Privater Konstruktor.
     * Die Steuerung soll nicht von auen erzeugt werden knnen.
     * Es soll lediglich ihre main-Methode aufgerufen werden
     * knnen.
     */
    private Steuerung ()
    {
    }
    
    /**
     * Lass den Vokabeltrainer im Mendialog laufen.
     */
    public static void main (String[] argumente)
    {
        Scanner leser = new Scanner (System.in);
        int antwort;
        
        /*
         * Begre den Benutzer.
         */
        System.out.println ("Willkommen bei " + version + ".");
        System.out.println (urheber);

        do
        {
            /*
             * Frage den Benutzer nach seinem nchsten Wunsch.
             */
            System.out.println ("1 -> Vokabeln laden");
            System.out.println ("2 -> Vokabeln eingeben");
            System.out.println ("3 -> Vokabeln ben");
            System.out.println ("4 -> Vokabeln speichern");
            System.out.println ("5 -> Ende");
            System.out.print ("> ");
            antwort = leser.nextInt ();
            
            /*
             * Reagiere entsprechend dem Wunsch den Benutzers.
             */
            switch (antwort)
            {
                case 1: Datenleser.gibDatenleser ().lies (); break;
                case 2: Vokabeleingabe.gibVokabeleingabe ().erfasse (); break;
                case 3: Trainer.gibTrainer ().uebe (); break;
                case 4: Datenschreiber.gibDatenschreiber ().schreibe (); break;
                
                /*
                 * Falls der Benutzer "Ende" gewhlt hat, gib ihm
                 * eine Chance, seine Meinung zu ndern.
                 */
                case 5:
                System.out.println ("Insgesamt " + Schlange.gibSchlange ().gibLaenge ()
                    + " Vokabeln in der Kartei.");
                System.out.println ("Wirklich beenden? (Andere Zahlen machen weiter.)");
                System.out.println ("5 -> Ende");
                System.out.print ("> ");
                antwort = leser.nextInt ();
                break;
            }
        }
        while (5 != antwort);
        
        /*
         * Verabschiede den Benutzer.
         */
        System.out.println (version + " sagt danke und wnscht viel Erfolg!");
        System.out.println (urheber);
    }
}
