/**
 * Eine Vokabel in der Vokabelkartei.
 * 
 * @author Bernd Gramlich
 * @version 2012-11-18
 */
public class Vokabel
{
    private String fremd;
    private String deutsch;
    
    private double punkte;
    private double wissen;

    /**
     * Konstruktor.
     * Erzeuge aus "fremdeBedeutung" und "deutscheBedeutung"
     * eine neue Vokabel. Die Vokabel hat anfangs einen
     * Wissensstand von 1 und einen Punktestand von 0.
     */
    public Vokabel (String fremdeBedeutung, String deutscheBedeutung)
    {
        fremd   = fremdeBedeutung;
        deutsch = deutscheBedeutung;
        
        punkte  = 0;
        wissen  = 1;
    }
    
    /**
     * Nenne die fremdsprachige Bedeutung der Vokabel.
     */
    public String gibFremd ()
    {
        return fremd;
    }
    
    /**
     * Nenne die deutsche Bedeutung der Vokabel.
     */
    public String gibDeutsch ()
    {
        return deutsch;
    }
    
    /**
     * Nenne die Punktzahl der Vokabel.
     */
    public double gibPunkte ()
    {
        return punkte;
    }
    
    /**
     * Nenne den Wissensstand der Vokabel.
     */
    public double gibWissen ()
    {
        return wissen;
    }
    
    /**
     * ndere die fremdsprachige Bedeutung der Vokabel.
     */
    public void setzeFremd (String fremdeBedeutung)
    {
        fremd = fremdeBedeutung;
    }
    
    /**
     * ndere die deutsche Bedeutung der Vokabel.
     */
    public void setzeDeutsch (String deutscheBedeutung)
    {
        deutsch = deutscheBedeutung;
    }
    
    /**
     * ndere die Punktzahl der Vokabel.
     */
    public void setzePunkte (double punktzahl)
    {
        punkte = punktzahl;
    }
    
    /**
     * ndere den Wissensstand der Vokabel.
     */
    public void setzeWissen (double wissensstand)
    {
        wissen = wissensstand;
    }
    
    /**
     * Erhhe den Wissensstand einer Vokabel. Das soll
     * geschehen, um zu dokumentieren, dass der Benutzer
     * die Vokabel beim Prfen gekannt hat.
     */
    public void erhoeheWissen ()
    {
        wissen = wissen * 1.25;
    }
    
    /**
     * Senke den Wissensstand einer Vokabel. Das soll
     * geschehen, um zu dokumentieren, dass der Benutzer
     * die Vokabel beim Prfen nicht gekannt hat.
     */
    public void senkeWissen ()
    {
        wissen = wissen * 0.6;
    }
    
    /**
     * Erhhe die Punktzahl der Vokabel. Das soll jeweils
     * getan werden, wenn die Vokabel geprft wurde, damit
     * sie an sinnvoller Stelle in die Vokabelkartei
     * einsortiert werden kann.
     */
    public void erhoehePunkte ()
    {
        punkte = punkte + wissen;
    }
    
    /**
     * Senke die Punktzahl der Vokabel. Damit sollen
     * ungewnschte Punkterhhungen wieder ausgeglichen
     * werden.
     */
    public void senkePunkte ()
    {
        punkte = punkte - wissen;
    }
    
    /**
     * Verschiebe die Punktzahl um die "summand". Das ist
     * sinnvoll, damit die vordersten Vokabeln in der Kartei
     * immer 0 Punkte (oder knapp darber) haben.
     */
    public void verschiebePunkte (double summand)
    {
        punkte = punkte + summand;
    }
}
