import java.util.Scanner;

/**
 * Eine primitive Klasse zum Erfassen von Vokabeln.
 * 
 * @author Bernd Gramlich 
 * @version 2012-11-17
 */
public class Vokabeleingabe
{
	private Scanner leser;
    
    private static Vokabeleingabe vokabeleingabeSingleton;

	/**
	 * Konstruktor.
     * Erzeuge einen "leser", der die Standardeingabe (Tastatur)
     * abfragt.
     * 
     * Der Konstruktor ist private, weil er von auen
     * nicht aufgerufen werden soll. Stattdessen soll
     * mit gibVokabeleingabe () auf die Vokabeleingabe
     * zugegriffen werden.
	 */
	private Vokabeleingabe ()
	{  
        leser = new Scanner (System.in);
	}
    
    /**
     * Gib die einzige verfgbare Vokabeleingabe zurck
     * (also den "vokabeleingabeSingleton"). Wenn die
     * Vokabeleingabe noch nicht erzeugt ist, erzeuge sie.
     */
    public static Vokabeleingabe gibVokabeleingabe ()
    {
        if (null == vokabeleingabeSingleton)
        {
            vokabeleingabeSingleton = new Vokabeleingabe ();
        }
        
        return vokabeleingabeSingleton;
    }
	
	/**
	 * Erfasse beliebig viele neue Vokabeln.
	 */
	public void erfasse ()
	{
		String antwort;

        do
        {
            /*
             * Frage den Benutzer nach der fremdsprachlichen und
             * der deutschen Bedeutung der neuen Vokabel.
             */
            System.out.print ("Fremdsprache? > ");
            String fremdeBedeutung = leser.nextLine ();
            System.out.print ("Deutsch? > ");
            String deutscheBedeutung = leser.nextLine ();
            
            /*
             * Erzeuge eine neue Vokabel mit diesen Bedeutungen
             * und fge sie passend in die Kartei ein.
             */
	        Schlange.gibSchlange ().fuegePassendEin
		        (new Vokabel (fremdeBedeutung, deutscheBedeutung));
            
            /*
             * Erfasse weitere Vokabeln, wenn der Benutzer nur die
             * Eingabetaste drckt. Hre auf, wenn er zuvor noch
             * eine andere Taste drckt.
             */
            System.out.print ("Weiter nur mit Eingabetaste, Ende mit anderer Taste zuvor. > ");
            antwort = leser.nextLine ();
        }
        while (antwort.equals (""));
	}
}
